# Overview

This is an autogenerated documentation about all available cukes step definitions.

Each steps contains a regular expression pattern and a short description of what this step is intended to be used for.

## General steps

Required dependencies:

**Maven**

```xml
<dependency>
    <groupId>lv.ctco.cukes</groupId>
    <artifactId>cukes-core</artifactId>
    <version>0.0.21</version>
</dependency>
```

**Gradle**

```
testCompile("lv.ctco.cukes:cukes-core:0.0.21");
```

### given

|Pattern|Description|
|-------|-----------|
|let variable "(.+)" equal to "(.+)"||
|let variable "(.+)" to be random UUID|Generates random UUID and assigns it to a variable|
|let variable "(\S+)" to be random password by matching pattern "([Aa0]+)"|Generates random password by given pattern. Pattern may contain symbils a,A,0. So A is replaced with random capital letter, a - with random letter and 0 - with random number|
|let variable "(\S+)" to be random password with length (\d+)|Generates random password with given length|
|let variable "(["]\*)" be equal to current timestamp||
|resources root is "(.+)"||
|value assertions are case-insensitive||

## HTTP steps

Required dependencies:

**Maven**

```xml
<dependency>
    <groupId>lv.ctco.cukes</groupId>
    <artifactId>cukes-http</artifactId>
    <version>0.0.21</version>
</dependency>
```

**Gradle**

```
testCompile("lv.ctco.cukes:cukes-http:0.0.21");
```

### given

|Pattern|Description|
|-------|-----------|
|accept "(.+)" mediaTypes||
|accept mediaType is JSON||
|authentication type is "(.+)"||
|baseUri is "(.+)"||
|content type is "(.+)"||
|content type is JSON||
|cookie "(.+)" with value "(.+)"||
|header (["]+) with value "(.+)"||
|param "(.+)" "(.+)"||
|proxy settings are "(http\|https)://([:]+)(?::(\d+))?"||
|queryParam "(.+)" is "(.+)"||
|session ID "(.+)" with value "(.+)"||
|session ID is "(.+)"||
|should wait at most (\d+) ([ ]+) with interval (\d+) ([ ]+) until header "(["]+)" equal to "(["]+)" or fail with "(["]+)"||
|should wait at most (\d+) ([ ]+) with interval (\d+) ([ ]+) until header "(["]+)" equal to "(["]+)"||
|should wait at most (\d+) ([ ]+) with interval (\d+) ([ ]+) until property "(["]+)" equal to "(["]+)" or fail with "(["]+)"||
|should wait at most (\d+) ([ ]+) with interval (\d+) ([ ]+) until property "(["]+)" equal to "(["]+)"||
|should wait at most (\d+) ([ ]+) with interval (\d+) ([ ]+) until status code (\d+) or fail with "(["]+)"||
|should wait at most (\d+) ([ ]+) with interval (\d+) ([ ]+) until status code (\d+)||
|username "(.+)" and password "(.+)"||

### then

|Pattern|Description|
|-------|-----------|
|header "(.+)" contains "(.+)"||
|header "(.+)" does not contain "(.+)"||
|header "(.+)" ends with pattern "(.+)"||
|header "(.+)" equal to "(.+)"||
|header "(.+)" is empty||
|header "(.+)" is not empty||
|header "(.+)" not equal to "(.+)"||
|it fails with "(.+)"||
|let variable "(.+)" equal to header "(.+)" value||
|let variable "(.+)" equal to property "(.+)" value||
|let variable "(.+)" equal to response body||
|response body does not contain "(.+)"||
|response body not equal to "(.\*)"||
|response contains "(.+)"||
|response contains an array "(.+)" of size (>=\|>\|<=\|<\|<>) (\d+)||
|response contains an array "(.+)" of size (\d+)||
|response contains an array "(["]+)" with object having property "(.+)" with value "(.+)"||
|response contains an array "(["]+)" with value "(.\*)"||
|response contains properties from file "(.+)"||
|response contains properties from json:||
|response contains property "(.+)" containing phrase "(.\*)"||
|response contains property "(.+)" matching pattern "(.+)"||
|response contains property "(.+)" not matching pattern "(.+)"||
|response contains property "(.+)" of type "(.+)"||
|response contains property "(.+)" with value "(.\*)"||
|response contains property "(.+)" with value other than "(.\*)"||
|response contains property "(.+)" with value:||
|response does not contain property "(.+)"||
|response equals to "(.\*)"||
|response is empty||
|response is not empty||
|status code is (\d+)||
|status code is not (\d+)||
|a failure is expected||

## GraphQL steps

Required dependencies:

**Maven**

```xml
<dependency>
    <groupId>lv.ctco.cukes</groupId>
    <artifactId>cukes-graphql</artifactId>
    <version>0.0.21</version>
</dependency>
```

**Gradle**

```
testCompile("lv.ctco.cukes:cukes-graphql:0.0.21");
```

### given

|Pattern|Description|
|-------|-----------|
|query from file "(.+)"||
|query variables from file "(.+)"||
|query:||

### when

|Pattern|Description|
|-------|-----------|
|the query is executed||

## LDAP steps

Required dependencies:

**Maven**

```xml
<dependency>
    <groupId>lv.ctco.cukes</groupId>
    <artifactId>cukes-ldap</artifactId>
    <version>0.0.21</version>
</dependency>
```

**Gradle**

```
testCompile("lv.ctco.cukes:cukes-ldap:0.0.21");
```

### given

|Pattern|Description|
|-------|-----------|
|LDAP server URL is "(.+)"||
|LDAP server can be connected by user with DN "(.+)" and password "(.+)"||
|change attribute "(.+)" (add\|remove\|replace) value "(.+)"||
|prepare new entity modification||
|the client imports LDIF:||

### when

|Pattern|Description|
|-------|-----------|
|the client creates entity using LDIF from file "(.+)"||
|the client creates entity using LDIF:||
|the client deletes entity with DN "(.+)"||
|the client retrieves entity by DN "(.+)"||
|the client searches entities within DN "(.+)" by filter "(.+)"||
|the client updates entity with DN "(.+)" using prepared modifications||

### then

|Pattern|Description|
|-------|-----------|
|entity contains attribute "([a-zA-Z][a-zA-Z0-9\-]\*)" matching pattern "(.+)"||
|entity contains attribute "([a-zA-Z][a-zA-Z0-9\-]\*)" not matching pattern "(.+)"||
|entity contains attribute "([a-zA-Z][a-zA-Z0-9\-]\*)" with (>=\|>\|<=\|<\|<>) (\d+) values?||
|entity contains attribute "([a-zA-Z][a-zA-Z0-9\-]\*)" with (\d+) values?||
|entity contains attribute "([a-zA-Z][a-zA-Z0-9\-]\*)" with value "(.\*)"||
|entity contains attribute "([a-zA-Z][a-zA-Z0-9\-]\*)" with value other than "(.\*)"||
|entity contains attribute "([a-zA-Z][a-zA-Z0-9\-]\*)"||
|entity does not contain attribute "([a-zA-Z][a-zA-Z0-9\-]\*)"||
|entity does not exist||
|entity exists||
|entity matches LDIF:||
|search result has size (>=\|>\|<=\|<\|<>) (\d+)||
|search result has size (\d+)||
|take entity with index (\d+) from search results||

## RabbitMQ steps

Required dependencies:

**Maven**

```xml
<dependency>
    <groupId>lv.ctco.cukes</groupId>
    <artifactId>cukes-rabbitmq</artifactId>
    <version>0.0.21</version>
</dependency>
```

**Gradle**

```
testCompile("lv.ctco.cukes:cukes-rabbitmq:0.0.21");
```

### given

|Pattern|Description|
|-------|-----------|
|bind queue "([a-zA-Z0-9_\-\.:]+)" to exchange "([a-zA-Z0-9_\-\.:]+)" with routing key "(.+)"||
|bind queue "([a-zA-Z0-9_\-\.:]+)" with routing key "(.+)"||
|connecting to host "(.+)"||
|connecting using username "(.+)" and password "(.+)"||
|content-type is "(.+)"||
|declare( durable)? exchange "([a-zA-Z0-9_\-\.:]+)" of type "(topic\|direct\|fanout)"||
|declare( durable)? exchange "([a-zA-Z0-9_\-\.:]+)"||
|message body is "(.+)"||
|message body:||
|not using SSL||
|prepare new message||
|reply-to is "(.+)"||
|server responds on port (\d+)||
|use exchange "([a-zA-Z0-9_\-\.:]+)" by default||
|using SSL||
|virtual host is "(.+)"||

### when

|Pattern|Description|
|-------|-----------|
|the client sends message to exchange "([a-zA-Z0-9_\-\.:]+)" with routing key "(.+)"||
|the client sends message with routing key "(.+)"||

### then

|Pattern|Description|
|-------|-----------|
|let variable "(.+)" equal to message body||
|message body contains "(.+)"||
|message body contains an array "(.+)" of size (>=\|>\|<=\|<\|<>) (\d+)||
|message body contains an array "(.+)" of size (\d+)||
|message body contains an array "(.+)" with value "(.\*)"||
|message body contains property "(.+)" containing phrase "(.\*)"||
|message body contains property "(.+)" matching pattern "(.+)"||
|message body contains property "(.+)" not matching pattern "(.+)"||
|message body contains property "(.+)" of type "(.+)"||
|message body contains property "(.+)" with value "(.\*)"||
|message body contains property "(.+)" with value other than "(.\*)"||
|message body does not contain "(.+)"||
|message body does not contain property "(.+)"||
|message body equals to "(.\*)"||
|message body is empty||
|message body is not empty||
|message body not equal to "(.\*)"||
|wait for message in queue "([a-zA-Z0-9_\-\.:]+)" for not more than (\d+) seconds||
|wait for message in queue "([a-zA-Z0-9_\-\.:]+)"||

## REST steps

Required dependencies:

**Maven**

```xml
<dependency>
    <groupId>lv.ctco.cukes</groupId>
    <artifactId>cukes-rest</artifactId>
    <version>0.0.21</version>
</dependency>
```

**Gradle**

```
testCompile("lv.ctco.cukes:cukes-rest:0.0.21");
```

### given

|Pattern|Description|
|-------|-----------|
|formParam "(.+)" is "(.+)"||
|request body "(.+)"||
|request body from binary file "(.+)"||
|request body from file "(.+)"||
|request body is a multipart file "(.+)"||
|request body is a multipart string "(.+)" with control "(.+)"||
|request body is a multipart string "(.+)" with mime-type "(.+)" and control "(.+)"||
|request body is a multipart with control "(.+)" from file "(.+)"||
|request body is a multipart with mime-type "(.+)" and control "(.+)" from file "(.+)"||
|request body:||

### when

|Pattern|Description|
|-------|-----------|
|the client performs (.+) request on "(.+)"||

